{% extends "paysans/farmspace.html" %}

{% block page_title %}
    Liste des paiements
{% endblock %}

{% block farm_content %}
    <form method="get" class="mb-4 d-flex flex-row align-items-center" id="filter_form">
        <div class="d-flex flex-row align-items-center">
            <label class="me-3" for="year_select">Année</label>
            <select name="year" id="year_select" class="form-select me-4" style="width: 6em;">
                {% for year in year_choices %}
                    <option value="{{ year }}">{{ year }}</option>
                {% endfor %}
            </select>

            <label class="me-3" for="period_select">Période</label>
            <select name="period" id="period_select" class="form-select" style="width: 13.5em;">
                <option value="S2">Février - Mai (S2)</option>
                <option value="summer">Juin - Septembre (été)</option>
                <option value="S1">Octobre - Janvier (S1)</option>
            </select>

            <a class="btn btn-secondary ms-4"
               href="{% url 'farm_payments_csv' ferme_id=ferme.id %}?year={{ year }}&period={{ period }}"
               target="_blank">
                <i class="fas fa-file-csv me-2"></i>
                Export CSV
            </a>
        </div>
    </form>

    <section>
        <div class="d-flex flex-row align-items-center justify-content-between mb-3">
            <h2 class="mb-0">Opérations</h2>

            <div class="d-inline-block" id="edit-btn-zone">
                <button class="btn btn-secondary" onclick="enable_editing_mode();">
                    <i class="fas fa-pen me-2"></i>
                    Mode édition
                </button>
            </div>
        </div>

        <div class="table-responsive">
        <table class="table table-striped table-hover align-middle">
            <thead>
            <tr>
                <th class="pe-4">
                    Date
                </th>
                <th class="pe-4">
                    De
                </th>
                <th class="pe-4">
                    Vers
                </th>
                <th class="pe-4 text-center">
                    Contrat N°
                </th>
                <th class="pe-4 text-end">
                    Montant
                </th>
                <th class="pe-4 text-center">
                    Paiement reçu ?
                </th>
                <th class="pe-4 text-center">
                    Mode de paiement
                </th>
                {% comment %}
                <th>
                    Actions
                </th>
                {% endcomment %}
            </tr>
            </thead>
            <tbody>
            {% for operation in operations %}
                <tr>
                    <td class="pe-4">
                        {{ operation.date_enregistrement|date:"d/m/Y" }}
                    </td>
                    <td class="pe-4">
                        {{ operation.get_debiteur_label }}
                    </td>
                    <td class="pe-4">
                        {{ operation.get_crediteur_label }}
                    </td>
                    <td class="pe-4 text-center">
                        {% if operation.contrat is not None %}
                            <a href="{% url 'farm_contract_details' ferme_id=ferme.id contract_id=operation.contrat.id %}" target="_blank">
                                {{ operation.contrat.id }}
                            </a>
                        {% endif %}
                    </td>
                    <td class="pe-4 text-end">
                        {{ operation.montant|floatformat:2 }} €
                    </td>
                    <td class="pe-4 text-center operation-status-zone" operation_id="{{ operation.id }}"
                        id="operation_status_{{ operation.id }}"
                        {% if operation.statut == operation.Statuts.FERME_RECU %}
                            value_checked="1"
                        {% else %}
                            value_checked="0"
                        {% endif %}
                    >
                        {% if operation.statut == operation.Statuts.FERME_RECU %}
                            <i class="far fa-check-square"></i>
                        {% else %}
                            <i class="far fa-square"></i>
                        {% endif %}
                    </td>
                    <td class="pe-4 text-center operation-mode-paiement-zone" operation_id="{{ operation.id }}"
                        id="operation_mode_paiement_{{ operation.id }}" current_value={{ operation.mode_paiement }} current_label="{{ operation.get_paiement_label }}">
                        {{ operation.get_paiement_label }}
                    </td>
                    {% comment %}
                    <td class="text-decoration-line-through">
                        <!-- TODO detailed view for operations -->
                        Détails
                    </td>
                    {% endcomment %}
                </tr>
            {% endfor %}
            {% if operations|length == 0 %}
            <tr>
                <td colspan="7" class="text-center">
                Aucun résultat
                </td>
            </tr>
    {% endif %}
            </tbody>
        </table>
        </div>

        {% pagination_widget operations request %}
    </section>
{% endblock %}

{% block scripts %}
    <script>
        function submit_filter_form() {
            $("#filter_form").submit();
        }

        const period_select = $("#period_select");
        const year_select = $("#year_select");

        period_select.val("{{ period }}");
        year_select.val("{{ year }}");

        period_select.change(submit_filter_form);
        year_select.change(submit_filter_form);

        let editions_statut = {};

        function enable_editing_mode() {
            editions_statut = {};
            editions_paiements = {};

            $(".operation-status-zone").each((index, element) => {
                let operation_id = $(element).attr("operation_id");
                let value_checked = $(element).attr("value_checked");

                $(element).html(
                    `<input type="checkbox" id="operation_check_${operation_id}" ${value_checked === "1" ? "checked" : ""} />`
                );

                let checkbox = $("#operation_check_" + operation_id);
                checkbox.change((event) => {
                    editions_statut[operation_id] = checkbox.prop("checked");
                });
            });

            $(".operation-mode-paiement-zone").each((index, element) => {
                let operation_id = $(element).attr("operation_id");
                let current_value = $(element).attr("current_value");

                $(element).html(
                    `
                    <select class="form-control" id="operation_mode_paiement_${operation_id}">
                        <option value="" ${current_value === "" ? "selected" : ""}>Aucun</option>
                        <option value="1" ${current_value === "1" ? "selected" : ""}>Carte Bancaire</option>
                        <option value="2" ${current_value === "2" ? "selected" : ""}>Espèces</option>
                        <option value="3" ${current_value === "3" ? "selected" : ""}>Chèque</option>
                        <option value="4" ${current_value === "4" ? "selected" : ""}>Virement</option>
                    </select>
                    `
                );

                let select = $("#operation_mode_paiement_" + operation_id);
                select.change((event) => {
                    editions_paiements[operation_id] = select.find(":selected").val();
                });
            });

            $("#edit-btn-zone").html(
                `<button class="btn btn-secondary me-3" onclick="disable_editing_mode()" id="btn_cancel_edit">
                   <i class="fas fa-times me-2"></i>
                    Annuler
                </button>
                <button class="btn btn-success" onclick="confirm_edits()" id="btn_confirm_edit">
                    <i class="fas fa-check me-2"></i>
                    Valider
                </button>`
            );
        }

        function disable_editing_mode() {
            editions_statut = {};
            editions_paiements = {};

            $(".operation-status-zone").each((index, element) => {
                let operation_id = $(element).attr("operation_id");
                let value_checked = $(element).attr("value_checked");

                if(value_checked === "1") {
                    $(element).html(
                        `<i class="far fa-check-square"></i>`
                    );
                }
                else {
                    $(element).html(
                        `<i class="far fa-square"></i>`
                    );
                }
            });

            $(".operation-mode-paiement-zone").each((index, element) => {
                let operation_id = $(element).attr("operation_id");
                let current_value = $(element).attr("current_value");
                let current_label = $(element).attr("current_label");

                $(element).html(
                    `${current_label}`
                );
            });

            $("#edit-btn-zone").html(
                `<button class="btn btn-secondary" onclick="enable_editing_mode();">
                    <i class="fas fa-pen me-2"></i>
                    Mode édition
                </button>`
            );
        }

        function confirm_edits() {
            $("#btn_confirm_edit").prop("disabled", true);
            $("#btn_cancel_edit").prop("disabled", true);

            $.ajax({
                url: "{% url 'farm_payments_list' ferme_id=ferme.id %}",
                method: "POST",
                headers: {
                    "X-CSRFToken": getCookie("csrftoken")
                },
                contentType: "application/json",
                data: JSON.stringify([editions_statut, editions_paiements]),
                error: (jqXHR, status, error) => {
                    alert("Une erreur est survenue lors de l'envoi des données : " + status + " " + error +
                          ". Veuillez contacter le support.");
                    $("#btn_confirm_edit").prop("disabled", false);
                    $("#btn_cancel_edit").prop("disabled", false);
                },
                success: (data, status, jqXHR) => {
                    window.location.reload();
                }
            });
        }
    </script>
{% endblock %}
